require:
  - rubocop-rails
  - rubocop-performance
  - rubocop-rspec
  - rubocop-factory_bot

AllCops:
  NewCops: disable
  Exclude:
    - bin/**/*
    - vendor/**/*
    - node_modules/**/*
    - helpers/**/*

Metrics/AbcSize:
  Enabled: false

Metrics/BlockLength:
  Exclude:
    - config/environments/*.rb
    - spec/**/*
    - app/api/v1/**/*
    - app/api/v2/**/*

Metrics/MethodLength:
  Enabled: true
  Max: 15
  CountAsOne:
    - array
    - hash
    - heredoc

Layout/LineLength:
  Enabled: true
  Max: 120

Layout/SpaceAroundMethodCallOperator:
  Enabled: true

Layout/FirstHashElementIndentation:
  Enabled: true
  EnforcedStyle: consistent

Lint/RaiseException:
  Enabled: true

Lint/StructNewOverride:
  Enabled: true

Lint/MissingSuper:
  Enabled: false

Style/Documentation:
  Enabled: false

Style/ExponentialNotation:
  Enabled: true

Style/HashEachMethods:
  Enabled: true

Style/HashTransformKeys:
  Enabled: true

Style/HashTransformValues:
  Enabled: true

Style/StringLiterals:
  Enabled: true
  EnforcedStyle: double_quotes

Style/FrozenStringLiteralComment:
  Enabled: true
  EnforcedStyle: always
  SafeAutoCorrect: true

Style/Alias:
  EnforcedStyle: prefer_alias_method

Style/HashSyntax:
  Enabled: false

Rails/HasManyOrHasOneDependent:
  Enabled: false

Rails/ActiveRecordAliases:
  Enabled: false

RSpec/MultipleExpectations:
  Max: 4

RSpec/NestedGroups:
  Max: 4

RSpec/MultipleMemoizedHelpers:
  Enabled: false

RSpec/ExampleLength:
  Max: 15

RSpec/DescribeClass:
  Exclude:
    - spec/e2e/**/*_spec.rb

RSpec/ContextWording:
  Exclude:
    - spec/api/**/*_spec.rb

Rails/FindEach:
  Enabled: false
